<?php
use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XMobileSmartClientProfile StructType
 * @subpackage Structs
 */
class XMobileSmartClientProfile extends AbstractStructBase
{
    /**
     * The name
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The mobileSmartClient
     * Meta informations extracted from the WSDL
     * - default: CUMC
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $mobileSmartClient;
    /**
     * The enableSnrUri
     * Meta informations extracted from the WSDL
     * - default: x-cisco-serviceuri-mobileconnect
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $enableSnrUri;
    /**
     * The enableCFAUri
     * Meta informations extracted from the WSDL
     * - default: x-cisco-serviceuri-cfwdall
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $enableCFAUri;
    /**
     * The handOffUri
     * Meta informations extracted from the WSDL
     * - default: x-cisco-serviceuri-handoff
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $handOffUri;
    /**
     * Constructor method for XMobileSmartClientProfile
     * @uses XMobileSmartClientProfile::setName()
     * @uses XMobileSmartClientProfile::setMobileSmartClient()
     * @uses XMobileSmartClientProfile::setEnableSnrUri()
     * @uses XMobileSmartClientProfile::setEnableCFAUri()
     * @uses XMobileSmartClientProfile::setHandOffUri()
     * @param string $name
     * @param string $mobileSmartClient
     * @param string $enableSnrUri
     * @param string $enableCFAUri
     * @param string $handOffUri
     */
    public function __construct($name = null, $mobileSmartClient = 'CUMC', $enableSnrUri = 'x-cisco-serviceuri-mobileconnect', $enableCFAUri = 'x-cisco-serviceuri-cfwdall', $handOffUri = 'x-cisco-serviceuri-handoff')
    {
        $this
            ->setName($name)
            ->setMobileSmartClient($mobileSmartClient)
            ->setEnableSnrUri($enableSnrUri)
            ->setEnableCFAUri($enableCFAUri)
            ->setHandOffUri($handOffUri);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return XMobileSmartClientProfile
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($name)), __LINE__);
        }
        $this->name = $name;
        return $this;
    }
    /**
     * Get mobileSmartClient value
     * @return string
     */
    public function getMobileSmartClient()
    {
        return $this->mobileSmartClient;
    }
    /**
     * Set mobileSmartClient value
     * @uses XMobileSmartClient::valueIsValid()
     * @uses XMobileSmartClient::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $mobileSmartClient
     * @return XMobileSmartClientProfile
     */
    public function setMobileSmartClient($mobileSmartClient = 'CUMC')
    {
        // validation for constraint: enumeration
        if (!XMobileSmartClient::valueIsValid($mobileSmartClient)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $mobileSmartClient, implode(', ', XMobileSmartClient::getValidValues())), __LINE__);
        }
        $this->mobileSmartClient = $mobileSmartClient;
        return $this;
    }
    /**
     * Get enableSnrUri value
     * @return string
     */
    public function getEnableSnrUri()
    {
        return $this->enableSnrUri;
    }
    /**
     * Set enableSnrUri value
     * @param string $enableSnrUri
     * @return XMobileSmartClientProfile
     */
    public function setEnableSnrUri($enableSnrUri = 'x-cisco-serviceuri-mobileconnect')
    {
        // validation for constraint: string
        if (!is_null($enableSnrUri) && !is_string($enableSnrUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($enableSnrUri)), __LINE__);
        }
        $this->enableSnrUri = $enableSnrUri;
        return $this;
    }
    /**
     * Get enableCFAUri value
     * @return string
     */
    public function getEnableCFAUri()
    {
        return $this->enableCFAUri;
    }
    /**
     * Set enableCFAUri value
     * @param string $enableCFAUri
     * @return XMobileSmartClientProfile
     */
    public function setEnableCFAUri($enableCFAUri = 'x-cisco-serviceuri-cfwdall')
    {
        // validation for constraint: string
        if (!is_null($enableCFAUri) && !is_string($enableCFAUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($enableCFAUri)), __LINE__);
        }
        $this->enableCFAUri = $enableCFAUri;
        return $this;
    }
    /**
     * Get handOffUri value
     * @return string
     */
    public function getHandOffUri()
    {
        return $this->handOffUri;
    }
    /**
     * Set handOffUri value
     * @param string $handOffUri
     * @return XMobileSmartClientProfile
     */
    public function setHandOffUri($handOffUri = 'x-cisco-serviceuri-handoff')
    {
        // validation for constraint: string
        if (!is_null($handOffUri) && !is_string($handOffUri)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($handOffUri)), __LINE__);
        }
        $this->handOffUri = $handOffUri;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return XMobileSmartClientProfile
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
